
c     CONVERTS A REAL MATRIX INTO A PostScript IMAGE FILE

      subroutine ar2psd (filename,arrd,nxd,nx,ny,psmind,psmaxd)
      parameter (WIDTH=450,HEIGHT=300,XLL=50,YLL=50)
      character*(*) filename
      real*8 arrd(nxd,ny)
      real*4 arr(nxd,ny)
      integer nxd,nx,ny
      real*8 psmind,psmaxd
      real*4 psmin,psmax
      character*60 hexstring
      
      do j=1,ny
         do i=1,nx
            arr(i,j)=sngl(arrd(i,j))
         enddo
      enddo
      psmin=sngl(psmind)
      psmax=sngl(psmaxd)

c OPEN OUTPUT FILE

      open(unit=77,file=filename,status='unknown')

c WRITE PostScript PRELIMINARY JUNK
    
      write (77,*) '%%!PS-Adobe-2.0 EPSF-2.0'
      write (77,*) '%%Creator: arr2ps'
      write (77,*) '%%Title: ',filename
      write (77,*) '%%Pages: 1'
      write (77,*) '%%BoundingBox: 0 0 ',
     &             XLL+WIDTH+100,YLL+HEIGHT+50
      write (77,*) '%%CreationDate: Unknown'
      write (77,*) '%%EndComments'
      write (77,*) '%%EndProlog'
      write (77,*) '%%Page: 1 1'
      write (77,*) '%% SAVE CURRENT GRAPHICS STATE'
      write (77,*) 'gsave'
      write (77,*) '%% EDITABLE DEFINITIONS: IF YOU CHANGE SOMETHING'
      write (77,*) '%% REMEMBER TO CHECK BoundingBox!'
      write (77,*) '/XLowLeft   ',XLL,' def'
      write (77,*) '/YLowLeft   ',YLL,' def'
      write (77,*) '/Width      ',WIDTH,' def'
      write (77,*) '/Height     ',HEIGHT,' def'
      write (77,*) '/Helvetica findfont 10 scalefont setfont'
      write (77,*) '0.1 setgray'
      write (77,*) '0.0 setlinewidth'
      write (77,*) '%% DO NOT CHANGE THESE!'
      write (77,*) '/PixWidth   ',nx,' def'
      write (77,*) '/PixHeight  ',ny,' def'
      write (77,*) '/BitsPerPix 8 def'
      write (77,*) '/String'
      write (77,*) ' PixWidth BitsPerPix mul'
      write (77,*) ' 7 add 8 idiv'
      write (77,*) ' string'
      write (77,*) ' def'
      write (77,*) 'XLowLeft YLowLeft translate'

c FIND MIN, MAX

      n=0
      if (psmin .ne. psmax) then
         fmin = psmin
         fmax = psmax
      else
         fmax = -1.e33
         fmin = -fmax
         do j=1,ny
            do i=1,nx
               f = arr(i,j)
               if (f.gt.fmax) fmax=f
               if (f.lt.fmin) fmin=f
            enddo
         enddo
      endif

c PRODUCE PostScript IMAGE OUTPUT

      write (77,*) '%% THE IMAGE'
      write (77,*) 'gsave'
      write (77,*) ' Width Height scale'
      write (77,*) ' PixWidth PixHeight BitsPerPix'
      write (77,*) ' [PixWidth 0 0 PixHeight neg 0 PixHeight]'
      write (77,*) ' {currentfile String readhexstring pop}'
      write (77,*) ' image'

      dff=(fmax-fmin)/255
      call hexcat(-1,hexstring)
      do j=1,ny
         do i=1,nx
            m = (arr(i,j)-fmin)/dff
            call hexcat (m,hexstring)
            n = n+1
            if (n .eq. 20) then
               write (77,*) hexstring
               n = 0
               call hexcat(-1,hexstring)
            endif
         enddo
      enddo
      write (77,*) 'grestore'
      write (77,*) '%% BOX AROUND THE IMAGE'
      write (77,*) '0 0 moveto'
      write (77,*) '0 Height lineto'
      write (77,*) 'Width Height lineto'
      write (77,*) 'Width 0 lineto'
      write (77,*) '0 0 lineto'
      write (77,*) 'stroke'

c SHOW IMAGE GREYSCALE

      write (77,*) '%% THE GRAYSCALE STRIP'
      write (77,*) 'gsave'
      write (77,*) ' Width 30 add 0 translate'
      write (77,*) ' gsave'
      write (77,*) ' 90 rotate'
      write (77,*) ' Height 10 scale'
      write (77,*) ' 100 1 8'
      write (77,*) ' [100 0 0 1 neg 0 1]'
      write (77,*) ' {currentfile String readhexstring pop}'
      write (77,*) ' image'

      df = (fmax-fmin)/99.0
      n = 0
      call hexcat(-1,hexstring)
      do i=1,100
         f = fmin+df*(i-1)
         m = (f-fmin)/dff
         call hexcat (m,hexstring)
         n = n+1
         if (n .eq. 20) then
            write (77,*) hexstring
            n = 0
            call hexcat(-1,hexstring)
         endif
      enddo
      if (n .ne. 0) write (77,*) hexstring

      write (77,*) ' grestore'
      write (77,*) ' %% WITH A BOX AROUND IT'
      write (77,*) ' -10 0 moveto'
      write (77,*) ' -10 Height lineto'
      write (77,*) ' 0 Height lineto'
      write (77,*) ' 0 0 lineto'
      write (77,*) ' -10 0 lineto'
      write (77,*) ' stroke'
      write (77,*) ' %% AND LABELS'
      write (77,*) ' 5 -3 moveto (',fmin,') show'
      write (77,*) ' 5 Height 5 sub moveto (',fmax,') show'
      write (77,*) 'grestore'

c     write (77,*) '%% DISPLAY DIMENSIONS OF IMAGE'
c     write (77,*) '0 -20 moveto (NX=',nx,', NY=',ny,') show'

      write (77,*) '%% RETURN TO ORIGINAL GRAPHICS STATE AND DISPLAY'
      write (77,*) 'grestore'
      write (77,*) 'showpage'
      write (77,*) '%%Trailer'

c FINIS

      close(unit=77)
      return
      end

      subroutine hexcat (m,string)
      integer m
      character*(*) string
      common /private/ lcurr
      character*1  hex(16)
      data hex /'0','1','2','3','4','5','6','7',
     &          '8','9','a','b','c','d','e','f'/

      if (m .lt. 0) then
         lcurr=0
      else
         if (m .lt.   0) m=0
         if (m .gt. 255) m=255
         string(lcurr+1:)=hex(m/16+1) // hex(m-16*(m/16)+1) // ' '
         lcurr=lcurr+3
      endif

      return
      end
