c     1D Cartesian alpha-Omega-dynamo as eigenvalue problem
c     real*8, Eispack and Recipes routines
c     eigenvalue and eigenvector for antisymmetric solution    

      program dynew
      parameter (nd=50,nnd=nd+nd,nx=50,nt=100)
      implicit real*8 (a-h,o-z)
      complex*16 bf,b,ew
      dimension gmat(nnd,nnd),ewr(nnd),ewi(nnd),ev(nnd,nnd),iv1(nnd),
     .          fv1(nnd),ind(nnd),b(nnd),bfr(nt,nx),
     .          evr(nnd,nnd),evi(nnd,nnd),t(nt),x(nx)
 
      print *
      print *, 'Input: Number of expansion coefficients, ',
     .         'dynamo number, mode number'
      print *, 'n, p, nmode'
      print *
      read *, n,p,nmode
      if (n.gt.nd) stop 'n>nd'
      if (nmode.gt.nd) stop 'nmode>nd'
      nn=n+n
      ph=0.5d0*p
      
      do i=1,nn
         do j=1,nn
            gmat(i,j)=0.d0
         enddo
      enddo

      do i=1,nn
         ri=dfloat(i)
         gmat(i,i)=-ri*ri
      enddo

      do i=2,nn-2,2
         gmat(i,i-1)=0.5d0*dfloat(i-1)
         gmat(i,i+1)=-0.5d0*dfloat(i+1)
      enddo
      gmat(nn,nn-1)=0.5d0*dfloat(nn-1)

      do i=3,nn-1,2
         gmat(i,i-1)=ph
         gmat(i,i+1)=ph
      enddo
      gmat(1,2)=ph

      call rg (nnd,nn,gmat,ewr,ewi,1,ev,iv1,fv1,ierr)
      if (ierr.ne.0) stop 'ierr ne 0 in rg'
      
      do i=1,nn
         do j=1,nn
            if (ewi(j).gt.0.d0) then
               evr(i,j)=ev(i,j)
               evi(i,j)=ev(i,j+1)
            endif
            if (ewi(j).eq.0.d0) then
               evr(i,j)=ev(i,j)
               evi(i,j)=0.d0
            endif
            if (ewi(j).lt.0.d0) then
               evr(i,j)=ev(i,j-1)
               evi(i,j)=-ev(i,j)               
            endif
         enddo
      enddo
      
      call indexd (nn,ewr,ind)

      nm=ind(nn-nmode+1)
      print *
      print 1000, p,ewr(nm),ewi(nm)
1000  format (f20.10,2d20.10)
      
      ew=dcmplx(ewr(nm),ewi(nm))
      do i=2,nn,2
         b(i)=dcmplx(evr(i,nm),evi(i,nm))
      enddo

      pi=2.d0*dasin(1.d0)
      do it=1,nt
         t(it)=dfloat(it-1)*2.d0*pi/dabs(ewi(nm))/(dfloat(nt-1)/2.)
         do ix=1,nx
            x(ix)=dfloat(ix-1)*pi/dfloat(nx-1)
            bf=(0.d0,0.d0)
            do i=2,nn,2
               bf=bf+b(i)*dsin(float(i)*x(ix))
            enddo
            bf=bf*cdexp(ew*t(it))
            bfr(it,ix)=dreal(bf)
         enddo
      enddo
      
      open (14,file='field.ew',status='unknown',form='formatted')
      write (14,1010) nt,nx
1010  format (2i10)
      do it=1,nt
         write (14,1020) t(it)
      enddo
      do ix=1,nx
         write (14,1020) x(ix)
      enddo
      do it=1,nt
         do ix=1,nx
            write (14,1020) bfr(it,ix)
         enddo
      enddo
1020  format (f15.5)
      close (14)

      call ar2psd ('dynew.ps',bfr,nt,nt,nx,0.d0,0.d0)

      end
