c     1D Cartesian alpha-Omega-dynamo as eigenvalue problem
c     real*8, Eispack and Recipes routines 
c     eigenvalues for various dynamo numbers
c     antisymmetric solution   

      program dynewp
      parameter (nd=50,nnd=nd+nd)
      implicit real*8 (a-h,o-z)
      dimension gmat(nnd,nnd),ewr(nnd),ewi(nnd),ev(1,1),iv1(nnd),
     .          fv1(nnd),ind(nnd),gmat1(nnd,nnd)

      print *
      print *, 'Input: n / number of expansion coefficients'
      print *
      read *, n
      if (n.gt.nd) stop 'n>nd'
      nn=n+n

      do i=1,nn                        ! initialize matrix
         do j=1,nn
            gmat(i,j)=0.d0
         enddo
      enddo

      do i=1,nn                        ! diagonal elements
         ri=dfloat(i)
         gmat(i,i)=-ri*ri
      enddo

      do i=2,nn-2,2                    ! sub- and superdiagonal elements
         gmat(i,i-1)=0.5d0*dfloat(i-1) ! toroidal component
         gmat(i,i+1)=-0.5d0*dfloat(i+1)
      enddo
      gmat(nn,nn-1)=0.5d0*dfloat(nn-1)

10    print *
      print *, 'Input: pa,pe,dp,iflag / stops if iflag<0 / ',
     .         'dynamo numbers'
      print *
      read *, pa,pe,dp,iflag
      if (iflag.lt.0) stop 'normal stop'
      
      do p=pa,pe,dp                    ! step through dynamo numbers

         ph=0.5d0*p

         do i=3,nn-1,2                 ! sub- and superdiagonal elements
            gmat(i,i-1)=ph             ! poloidal component
            gmat(i,i+1)=ph
         enddo
         gmat(1,2)=ph

         do i=1,nn                     ! copy of matrix
            do j=1,nn
               gmat1(i,j)=gmat(i,j)
            enddo
         enddo

         call rg (nnd,nn,gmat1,ewr,ewi,0,ev,iv1,fv1,ierr) ! compute eigenvalues
         if (ierr.ne.0) stop 'ierr ne 0 in rg'            ! Eispack routines

         call indexd (nn,ewr,ind)                         ! sort eigenvalues
                                                          ! Recipes routine
         print *                                          
         print 1000, p,ewr(ind(nn)),ewi(ind(nn))          ! print first  
         do i=1,4                                         ! five eigenvalues
            print 1010, ewr(ind(nn-i)),ewi(ind(nn-i))
         enddo
1000     format (f20.10,2d20.10)
1010     format (20x,2d20.10)

      enddo

      goto 10                          ! repeat with other dynamo numbers

      end
