c       subroutine strlp (a,nu,nv,ha,char,nops)                        
c                                                                      
c       usage                                                         
c                                                                    
c          call  strlp (a,nu,nv,ha,char,nops)                      
c                                                                  
c       purpose                                                   
c                                                                
c          plot  contours  of  arrays  on  line  printer        
c                                                              
c       parameters                                            
c                                                            
c          a   array  to  be  shaded  contour  plotted      
c          nu  x  dimension  of  printing  raster          
c          nv  y  dimension  of  printing  raster         
c          ha  gives  first  and  second  level  for  contours  of  a  
c          char  contains  printing  character  set  for  plot        
c          nops  x dimension of array a in calling program           
c                                                                   
c       card format for reading in symbols.                        
c                                                                 
c          column 1        points below range                    
c          columns 2-68    levels in range                              
c          column 69       points above range                          
c          column 70       background field for line contours         
c          column 71       line contours                             
c          column 72       symbol for plotting box                  
c                                                                  
c.......................................................................
c
      subroutine strlp (a,nu,nv,ha,char,nops)                         
c                                                                      
      character*1 hl(130),char(72)                                    
      dimension a(nops,*),ha(2)                                      
c                                                                   
c            set plotting raster                                   
c                                                                
      write(6,202) (char(l),l=2,68), char(1),char(69)                   
      write(6,201) ha(1),char(2),ha(2),char(3)                         
 201  format(' first level:',1pe11.3,' symbol: ',a1,' ,  second level:' 
     &,1pe11.3,' symbol:  ',a1/)                                        
 202  format(1h ,'the symbols for the levels are: ',67a1//' points below 
     &range: ',a1,'  ,  points above range: ',a1/)                      
c                                                                     
c            define mesh points                                      
c                                                                   
      nu1=nu-1                                                     
      nv1=nv-1                                                    
c                                                                
      n0=72                                                     
      dha=1.0/(ha(2)-ha(1))                                    
c                                                            
c            define top line of plotting box                
c                                                          
      do 50 i=1,nu                                        
   50 hl(i)=char(n0)                                     
c                                                       
c            set symbols inside box                                     
c                                                                      
      do 107 j=1,nv1                                                  
c                                                                    
c            select y-mesh point                                    
c                                                                  
      ny=nv-j                                                     
      j1=j-1                                                     
      l=ny+1                                                    
c                                                              
      do 106 i=1,nu1                                          
c                                                            
c            select x-mesh point                            
c                                                          
      nx=i-1                                              
      k=i                                                
c                                                       
c            interpolate a                             
c                                                     
      ka=(a(k,l)-ha(1))*dha + 2.0                    
      ka = max0 (ka,1)                                                  
      ka = min0(ka,70)                                                 
c                                                                     
c            plot top edge of plotting box first time round do loops 
c                                                                   
 2505 if (nx) 38,38,2101                                           
 2101 if (j1) 38,38,60                                            
c                                                                
c            plot a                                             
c                                                              
 60   hl(i)=char(ka)                                          
c                                                            
 38   continue                                              
 106  continue                                             
c                                                         
c            draw edges of plotting box                  
c                                                       
      hl(1)=char(n0)                                   
      hl(nu)=char(n0)                                 
c                                                    
c            print line of output on printer        
c                                                                     
  107 write (6,101) (hl(i),i=1,nu)                                   
c                                                                   
c            draw bottom line of plotting box                      
c                                                                 
      do 51 i=1,nu                                               
   51 hl(i)=char(n0)                                            
      write (6,101) (hl(i),i=1,nu)                             
c                                                             
      return                                                 
c                                                           
  101 format (1x,130a1)                                    
c                                                        
      end                                               
